/*
	add some data to the table
*/
USE [AdventureWorks2016E];
GO

BEGIN TRANSACTION

BULK INSERT [AdventureWorks2016E].[Sales].[SalesOrderDetail]
FROM 'C:\SQLskills\QS\sod.txt'
	WITH
	(
	DATAFILETYPE = 'native',
	TABLOCK
	);
GO

EXEC [Sales].[usp_GetProductInfo] 870

COMMIT


/*
	a plan can be forced in the UI
	or with a SP
*/
EXEC [sys].[sp_query_store_force_plan] @query_id = 1, @plan_id = 1;


/*
	check status of forced plan
*/
SELECT p.plan_id, p.query_id, q.object_id as containing_object_id,
    force_failure_count, last_force_failure_reason_desc
FROM sys.query_store_plan AS p
JOIN sys.query_store_query AS q on p.query_id = q.query_id
WHERE is_forced_plan = 1;


select *
from sys.objects 
where object_id = 628913312

/*	
	stop all scripts
	what if I clear the cache?
*/
DBCC FREEPROCCACHE;
GO

/*
	what's in cache now?
*/
SET TRANSACTION ISOLATION LEVEL READ UNCOMMITTED;
GO
SELECT qs.execution_count, s.text, qs.query_hash, qs.query_plan_hash, cp.size_in_bytes/1024 [PlanSizeKB], qp.query_plan, qs.plan_handle
FROM sys.dm_exec_query_stats qs
CROSS APPLY sys.dm_exec_query_plan (qs.plan_handle) qp
CROSS APPLY sys.dm_exec_sql_text(qs.plan_handle) s
JOIN sys.dm_exec_cached_plans cp ON qs.plan_handle = cp.plan_handle;
GO
SET TRANSACTION ISOLATION LEVEL READ COMMITTED;
GO

/*
	run it with a big value
*/
SELECT [ProductID], COUNT(*)
FROM [Sales].[SalesOrderDetail]
GROUP BY [ProductID]
ORDER BY COUNT(*) DESC;
GO

EXEC [Sales].[usp_GetProductInfo] 711;
GO


/*
		check cache again for the plan
*/
SET TRANSACTION ISOLATION LEVEL READ UNCOMMITTED;
GO
SELECT qs.execution_count, s.text, qs.query_hash, qs.query_plan_hash, cp.size_in_bytes/1024 [PlanSizeKB], qp.query_plan, qs.plan_handle
FROM sys.dm_exec_query_stats qs
CROSS APPLY sys.dm_exec_query_plan (qs.plan_handle) qp
CROSS APPLY sys.dm_exec_sql_text(qs.plan_handle) s
JOIN sys.dm_exec_cached_plans cp ON qs.plan_handle = cp.plan_handle
WHERE s.text like '%GetProduct%';
GO
SET TRANSACTION ISOLATION LEVEL READ COMMITTED;
GO